Attribute VB_Name = "FUNCTI0NS"


Option Explicit
Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Private Declare Function sndStopSound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszNull As Long, ByVal uFlags As Long) As Long
Public Declare Function Netbios Lib "netapi32.dll" (pncb As NET_CONTROL_BLOCK) As Byte
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
Public Declare Function GetProcessHeap Lib "kernel32" () As Long
Public Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Public Declare Function GetComputerName Lib "kernel32" _
   Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long
Private Declare Function NetMessageBufferSend Lib "netapi32.dll" (yServer As Any, _
    yToName As Byte, yFromName As Any, yMsg As Byte, ByVal lSize As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function LogonUser Lib "Advapi32" Alias "LogonUserA" (ByVal lpszUsername As String, ByVal lpszDomain As Any, ByVal lpszPassword As String, ByVal dwLogonType As Long, ByVal dwLogonProvider As Long, phToken As Long) As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, _
                        ByVal hwndInsertAfter As Long, _
                        ByVal x As Long, _
                        ByVal y As Long, _
                        ByVal cx As Long, _
                        ByVal cy As Long, _
                        ByVal wFlags As Long) As Long

Global Const SND_SYNC = &H0
Global Const SND_ASYNC = &H1
Global Const SND_NODEFAULT = &H2
Global Const SND_LOOP = &H8
Global Const SND_NOSTOP = &H10
Global Const SND_MEMORY = &H4
Public Const HWND_TOPMOST = -1

Global MACA
Global moyenne     As Integer

Private Const FILTER_NORMAL_ACCOUNT As Long = &H2&
Private Const ERROR_MORE_DATA As Long = 234&
Private Const NERR_Success As Long = 0&
Public Const NCBASTAT As Long = &H33
Public Const NCBNAMSZ As Long = 16 'Lunghezza massima del NomeHost:  da protocollo NetBios, non cambiare!
Public Const HEAP_ZERO_MEMORY As Long = &H8
Public Const HEAP_GENERATE_EXCEPTIONS As Long = &H4
Public Const NCBRESET As Long = &H32


Public Type USER_INFO

    name As String
    Comment As String
    UserComment As String
    FullName As String
End Type

Public Type USER_INFO_API
    name As Long
    Comment As Long
    UserComment As Long
    FullName As Long
End Type

Public Type NET_CONTROL_BLOCK
   ncb_command    As Byte
   ncb_retcode    As Byte
   ncb_lsn        As Byte
   ncb_num        As Byte
   ncb_buffer     As Long
   ncb_length     As Integer
   ncb_callname   As String * NCBNAMSZ
   ncb_name       As String * NCBNAMSZ
   ncb_rto        As Byte
   ncb_sto        As Byte
   ncb_post       As Long
   ncb_lana_num   As Byte
   ncb_cmd_cplt   As Byte
   ncb_reserve(9) As Byte
   ncb_event      As Long
End Type

Public Type ADAPTER_STATUS
   adapter_address(5) As Byte
   rev_major         As Byte
   reserved0         As Byte
   adapter_type      As Byte
   rev_minor         As Byte
   duration          As Integer
   frmr_recv         As Integer
   frmr_xmit         As Integer
   iframe_recv_err   As Integer
   xmit_aborts       As Integer
   xmit_success      As Long
   recv_success      As Long
   iframe_xmit_err   As Integer
   recv_buff_unavail As Integer
   t1_timeouts       As Integer
   ti_timeouts       As Integer
   Reserved1         As Long
   free_ncbs         As Integer
   max_cfg_ncbs      As Integer
   max_ncbs          As Integer
   xmit_buf_unavail  As Integer
   max_dgram_size    As Integer
   pending_sess      As Integer
   max_cfg_sess      As Integer
   max_sess          As Integer
   max_sess_pkt_size As Integer
   name_count        As Integer
End Type

Public Type NAME_BUFFER
   name        As String * NCBNAMSZ
   name_num    As Integer
   name_flags  As Integer
End Type

Public Type ASTAT
   adapt          As ADAPTER_STATUS
   NameBuff(30)   As NAME_BUFFER
End Type
Private Declare Function NetUserEnum Lib "netapi32" _
  (lpServer As Any, ByVal Level As Long, ByVal Filter As Long, lpBuffer As Long, _
  ByVal PrefMaxLen As Long, EntriesRead As Long, TotalEntries As Long, ResumeHandle As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (pTo As Any, uFrom As Any, ByVal lSize As Long)
Private Declare Function NetApiBufferFree Lib "netapi32" (ByVal pBuffer As Long) As Long




Public Function PlayWav(Optional File As String)
On Error Resume Next
Dim rc As String
If File Then rc = sndPlaySound("", SND_ASYNC)
rc = sndPlaySound("FILE", SND_ASYNC)
End Function

Function NoiseGet(ByVal FileName) As String
Dim Buffer As String
Dim f As Integer
Dim SoundBuffer As String
    On Error GoTo NoiseGet_Error
    Buffer = Space$(1024)
    SoundBuffer = ""
    f = FreeFile
    Open FileName For Binary As f
    Do While Not EOF(f)
        Get #f, , Buffer     ' Load in 1K chunks
        SoundBuffer = SoundBuffer & Buffer
    Loop
    Close f
    NoiseGet = Trim$(SoundBuffer)
Exit Function

NoiseGet_Error:
    SoundBuffer = ""
    Exit Function
End Function

Sub NoisePlay(SoundBuffer As String, ByVal PlayMode As Integer)
Dim retcode As Integer
    If SoundBuffer = "" Then Exit Sub
    retcode = sndStopSound(0, SND_ASYNC)
    retcode = sndPlaySound(ByVal SoundBuffer, PlayMode Or SND_MEMORY)
End Sub

Public Function DMaca(ByVal NomeHost As String) As String
    On Error Resume Next
    Dim Tmp As String, pASTAT As Long
    Dim NCB As NET_CONTROL_BLOCK, AST As ASTAT
    Dim NGT As Boolean
    Dim t
    NCB.ncb_command = NCBRESET
    Call Netbios(NCB)
    NCB.ncb_callname = NomeHost
    NCB.ncb_command = NCBASTAT
    NCB.ncb_lana_num = 0
    NCB.ncb_length = Len(AST)
    pASTAT = HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS Or HEAP_ZERO_MEMORY, NCB.ncb_length)
    If pASTAT = 0 Then Exit Function
     NCB.ncb_buffer = pASTAT
    Call Netbios(NCB)
    CopyMemory AST, NCB.ncb_buffer, Len(AST)
    NGT = False
    For t = 0 To 5
        If AST.adapt.adapter_address(t) <> 0 Then
            NGT = True
            Exit For
        End If
    Next
    If NGT = True Then
        Tmp = Format$(Hex(AST.adapt.adapter_address(0)), "00") _
        & "-" & Format$(Hex(AST.adapt.adapter_address(1)), "00") _
        & "-" & Format$(Hex(AST.adapt.adapter_address(2)), "00") _
        & "-" & Format$(Hex(AST.adapt.adapter_address(3)), "00") _
        & "-" & Format$(Hex(AST.adapt.adapter_address(4)), "00") _
        & "-" & Format$(Hex(AST.adapt.adapter_address(5)), "00")
        HeapFree GetProcessHeap(), 0, pASTAT
        DMaca = Tmp
        MACA = DMaca
    Else
        DMaca = "UnKnown"
        MACA = "Unsolved"
    End If
End Function
Public Function BackSlash(ByVal sPath As String) As String
If Right(sPath, 1) = "\" Then BackSlash = sPath Else BackSlash = sPath & "\"
End Function
Public Function GetUsers(UserNames() As String, _
   Optional ServerName As String = "") As Boolean
    Dim lptrStrBuffer As Long
    Dim lRet As Long
    Dim lUsersRead As Long
    Dim lTotalUsers As Long
    Dim lHnd As Long
    Dim etUserInfo As USER_INFO_API
    Dim bytServerName() As Byte
    Dim lElement As Long
    Dim Users() As USER_INFO
    Dim i As Long
    ReDim Users(0) As USER_INFO
    ReDim UserNames(0) As String
    If Trim(ServerName) = "" Then
        bytServerName = vbNullString
    Else
        If InStr(ServerName, "\\") = 1 Then
            bytServerName = ServerName & vbNullChar
        Else
            bytServerName = "\\" & ServerName & vbNullChar
        End If
    End If
    lHnd = 0
 Do
         If Trim(ServerName) = "" Then
             lRet = NetUserEnum(vbNullString, 10, _
              FILTER_NORMAL_ACCOUNT, lptrStrBuffer, 1, _
               lUsersRead, lTotalUsers, lHnd)
         Else
             lRet = NetUserEnum(bytServerName(0), 10, _
              FILTER_NORMAL_ACCOUNT, lptrStrBuffer, 1, _
                lUsersRead, lTotalUsers, lHnd)
         End If
         For i = 0 To lUsersRead - 1
         DoEvents
           CopyMem etUserInfo, ByVal lptrStrBuffer + Len(etUserInfo) * i, _
 Len(etUserInfo)
           If Users(0).name = "" Then
               lElement = 0
           Else
               lElement = UBound(Users) + 1
           End If
           ReDim Preserve Users(lElement) As USER_INFO
           Users(lElement).name = PtrToString(etUserInfo.name)
           Users(lElement).Comment = PtrToString(etUserInfo.Comment)
           Users(lElement).UserComment = PtrToString(etUserInfo.UserComment)
           Users(lElement).FullName = PtrToString(etUserInfo.FullName)
            ReDim Preserve UserNames(lElement)
           UserNames(lElement) = Users(lElement).name
         Next

         If lptrStrBuffer Then
             Call NetApiBufferFree(lptrStrBuffer)
         End If
         DoEvents
         If lRet = NERR_Success Then Exit Do
     Loop While lRet = ERROR_MORE_DATA
 GetUsers = True
    Exit Function
ErrHandler:
On Error Resume Next
Call NetApiBufferFree(lptrStrBuffer)
End Function

Private Function PtrToString(lpString As Long) As String
    Dim bytBuffer() As Byte
    Dim lLen As Long
    If lpString Then
        lLen = lstrlenW(lpString) * 2
        If lLen Then
            ReDim bytBuffer(0 To (lLen - 1)) As Byte
            CopyMem bytBuffer(0), ByVal lpString, lLen
            PtrToString = bytBuffer
        End If
    End If
End Function
Public Function GetAppVer() As String
    GetAppVer = " v" & App.Major & "." & App.Minor & " "
End Function
Function ConvertIPAddressToLong(strAddress As String) As Long

    Dim strTemp             As String
    Dim lAddress            As Long
    Dim iValCount           As Integer
    Dim lDotValues(1 To 4)  As String
    
    strTemp = strAddress: iValCount = 0
        
        While InStr(strTemp, ".") > 0
        iValCount = iValCount + 1
        lDotValues(iValCount) = Mid(strTemp, 1, InStr(strTemp, ".") - 1)
        strTemp = Mid(strTemp, InStr(strTemp, ".") + 1)
        Wend
    iValCount = iValCount + 1
    lDotValues(iValCount) = strTemp
    If iValCount <> 4 Then
        ConvertIPAddressToLong = 0
        Exit Function
        End If
    lAddress = Val("&H" & Right("00" & Hex(lDotValues(4)), 2) & _
                Right("00" & Hex(lDotValues(3)), 2) & _
                Right("00" & Hex(lDotValues(2)), 2) & _
                Right("00" & Hex(lDotValues(1)), 2))
    ConvertIPAddressToLong = lAddress
End Function

Public Function BroadcastMessage(pDst As String, _
   pExp As String, pMsg As String) As Long
   Dim lDstName() As Byte
   Dim lExpName() As Byte
   Dim lMsg() As Byte
   Dim lRet As Long
   lDstName = pDst & vbNullChar
   lExpName = pExp & vbNullChar
   lMsg = pMsg & vbNullChar
   DoEvents
   lRet = NetMessageBufferSend(lExpName(0), lDstName(0), lExpName(0), lMsg(0), UBound(lMsg))
   BroadcastMessage = lRet
End Function

Function UserCheckPassword(ByVal username As String, ByVal Password As String, Optional ByVal Domain As String = vbNullString) As Boolean
    Dim lRet As Long, hToken As Long
    Const LOGON32_LOGON_NETWORK = 3&            'Intended for high performance servers to authenticate clear text passwords
    Const LOGON32_LOGON_INTERACTIVE = 2&        'Intended for users who will be interactively using the machine, such as a user being logged on by a terminal server
    Const LOGON32_LOGON_BATCH = 4&
    Const LOGON32_PROVIDER_DEFAULT = 0&         'Use the standard logon provider for the system
    Const LOGON32_PROVIDER_WINNT35 = 1&         'Use the Windows NT 3.5 logon provider
    Const LOGON32_PROVIDER_WINNT40 = 2&         'Use the Windows NT 4.0 logon provider
    Const LOGON32_PROVIDER_WINNT50 = 3&         'Use the Windows 2000 logon provider.
    'Check the username and password
    On Error Resume Next
    lRet = LogonUser(username, Domain, Password, LOGON32_LOGON_NETWORK, _
    LOGON32_PROVIDER_DEFAULT, hToken)
    
    If lRet Then 'Password correct
    UserCheckPassword = True: CloseHandle hToken
    Else 'Failed:
    MsgBox "Invalid Pasword" '& DLLErrorText(Err.LastDllError)
'    Debug.Print "Error: "
    'MsgBox sDomain
    End If '
End Function
